; @com.wudsn.ide.asm.mainsourcefile=mixgraphicmodes.asm
;******************************************************************
                icl "memory"

                ORG $8000

;                jsr main_init
                
;main            nop
;                jmp main

.proc @StartMGM
;main_init       
                sei
                
                jsr disable_roms
                jsr disable_irq
                jsr setup_nmi
                jsr setup_dma
                jsr setup_colors
                jsr setup_dli
                jsr switch_vbi
                ;jsr fill_screen
                cli
                rts
.endp

fill_screen     lda #<SCREENA
                sta ad1
                lda #>SCREENA
                sta ad1+1
                lda #<SCREENB
                sta ad2
                lda #>SCREENB
                sta ad2+1
                ldx #96
fill_screen_2   ldy #39
fill_screen_1   lda RANDOM
                sta (ad1),y
                and #$0F
                sta (ad2),y
                dey
                bpl fill_screen_1
                clc
                lda ad1
                adc #40
                sta ad1
                lda ad1+1
                adc #0
                sta ad1+1
                lda ad2
                adc #40
                sta ad2
                lda ad2+1
                adc #0
                sta ad2+1
                
                dex
                bne fill_screen_2

                rts

disable_roms    lda PORTB
                and #%01111100
                ora #%10000010
                sta PORTB
                rts
                
disable_irq     lda #$00
                sta IRQEN
                rts
                
setup_nmi       lda <vbi_handler0
                sta vbi_handler_jmp+1
                lda >vbi_handler0
                sta vbi_handler_jmp+2
                
                lda #<nmi_handler
                sta NMI
                lda #>nmi_handler
                sta NMI+1
                lda #%11000000
                sta NMIEN
                rts
                
switch_vbi      lda <vbi_handler
                sta vbi_handler_jmp+1
                lda >vbi_handler
                sta vbi_handler_jmp+2
                rts
                
setup_dli       lda #<DLIST
                sta DLISTL
                lda #>DLIST
                sta DLISTH
                rts
                
setup_colors    MVA #color_Black COLBK
                MVA #color_Red COLPF0
                MVA #color_Blue2 COLPF1    ;PAPER
                MVA #color_Dark_green COLPF2
                MVA #248 COLPF3
                MVA #242 COLPM0
                MVA #242 COLPM1
                MVA #116 COLPM2
                MVA #116 COLPM3
                rts

setup_dma       lda #%00110010 ;DListEnable+OneLinePMResolution+PMEnable+Wide
                sta DMACTL
                lda #0
                sta CHACTL
                lda #%111
                sta GRACTL
                rts

;INTERUPTS
nmi_handler     bit NMIST
                bpl nmi_not_dli 
                bmi dli_handler
nmi_not_vbi     lda #%00100000
                bit NMIST
                bne nmi_not_reset
                sta nmires
                rti
nmi_not_reset   pla
                rti
nmi_not_dli     pha
                bvc nmi_not_vbi
                txa
                pha
                tya
                pha
                sta NMIRES
vbi_handler_jmp jmp vbi_handler

dli_handler     pha
                txa
                pha
                tya
                pha
                lda #96
                sta POM

dli_handler_1   lda #COLOR1
                ldx #COLOR2
                ldy #COLOR3
                sta WSYNC
                sta COLPF0
                stx COLPF1
                sty COLPF2
                
                lda #4
                ldx #8
                ldy #15
                sta WSYNC
                sta COLPF0
                stx COLPF1
                sty COLPF2
                dec POM
                bne dli_handler_1
 
                pla
                tay
                pla
                tax                
                pla
                rti
                
vbi_handler0    pla
                tay
                pla
                tax
                pla
                rti

vbi_handler     MVA #$0E COLBK
                MVA #$00 COLBK

                pla
                tay
                pla
                tax
                pla
                rti

;*** DISPLAY LIST

                ORG DLISTSTART
DLIST           DTA BLANK8,BLANK8,BLANK8+DLI
DLIST_SCREEN
                DTA LMS+MODEE,a(SCREENA)
:95             DTA MODEE
                DTA LMS+MODEE,a(SCREENB)
:95             DTA MODEE

                DTA DLIJUMPEND,a(DLIST) ;temporary until dynamic dli is finished.

                ;ORG SCREENA
                ;ins "image.dat"